import type { BadgeAPI, BadgeStates, FocusableElement, InternalButtonProps, KolFocusOptions, KoliBriIconsProp, LabelPropType, PropColor, Stringified } from '../../schema';
import type { JSX } from '../../stencil-public-runtime';
export declare class KolBadge implements BadgeAPI, FocusableElement {
    protected readonly host?: HTMLKolBadgeElement;
    private bgColorStr;
    private colorStr;
    private readonly id;
    protected readonly ctaRef: import("../../utils/element-interaction").CtaRef<HTMLKolButtonWcElement>;
    private renderSmartButton;
    focus(options?: KolFocusOptions): Promise<void>;
    render(): JSX.Element;
    _color?: Stringified<PropColor>;
    _icons?: Stringified<KoliBriIconsProp>;
    _label: LabelPropType;
    _smartButton?: Stringified<InternalButtonProps>;
    state: BadgeStates;
    private handleColorChange;
    validateIcons(value?: KoliBriIconsProp): void;
    validateColor(value?: Stringified<PropColor>): void;
    validateSmartButton(value?: InternalButtonProps | string): void;
    componentWillLoad(): void;
}
